/* gamemain2.c */
#include<scenario.h>
#include<screen.h>
#include<gameio.h>
#include<walls.h>
#include<stdio.h>
#include<enemy.h>
#include<enemyrika.h>
#include<myenemy.h>
#include<enemy_yuriko.h>
#include<movingobjectmanager.h>
#ifdef DEBUG
#include<log.h>
#endif

#define OBJNUM 2
#define MOBJNUM 9
#define EVNUM 15

object* objp[OBJNUM];
movingobject* mobjp[MOBJNUM];

event* ev[EVNUM];
vector2 mypos;
int isfire;
int score;
int speedlevel;

void onestepb(movingobject* mobj){
  vec2add(&(mobj->pos), &(mobj->vel));
}

void dispb(movingobject* mobj){
  putobject(*(mobj->obj), mobj->id, mobj->pos.x, mobj->pos.y);
}

void dispm(movingobject* mobj){
  putobject(*(mobj->obj), 0, mobj->pos.x, mobj->pos.y);
}

int bomba(movingobject* mobj){
  score += 100;
  return 1;
}

void initobjects(void){
  objp[0] = newobject(1,1,"x");
  objp[1] = newobject(3,2," ^ =x=");
}

void initmovingobjects(void){
  mobjp[0] = newenemy();
  mobjp[1] = newmovingobject(&objp[0], onestepb, dispb, bomba, "bullet");
  mobjp[2] = newmovingobject(&objp[1], NULL, dispm, bomba, "me");
  mobjp[3] = newenemy4();
  mobjp[4] = newenemy1();
  mobjp[5] = newenemy2();
  mobjp[6] = newenemy3();
  mobjp[7] = originalenemy1();
  mobjp[8] = originalenemy2();
}

void setevents(void){
  int i;
  ev[0] = newevent(10, makevector2(30,5),makevector2(0.3,0.2), mobjp[0],"plus0");
  ev[1] = newevent(30, makevector2(5,5),makevector2(0.5,0.3), mobjp[3],"plus1");
  ev[2] = newevent(45, makevector2(15,5),makevector2(-0.1,0.3), mobjp[4],"plus2");
  ev[3] = newevent(65, makevector2(30,12),makevector2(0.1,0.2), mobjp[5],"plus3");
  ev[4] = newevent(80, makevector2(20,5),makevector2(0,0.3), mobjp[6],"plus4");
  ev[5] = newevent(110, makevector2(25,5),makevector2(-0.5,0.3), mobjp[7],"plus5");
  ev[6] = newevent(130, makevector2(10,3),makevector2(0.5,0.3), mobjp[8],"plus6");
  ev[7] = newevent(145, makevector2(20,6),makevector2(0.1,0.2), mobjp[0],"plus7");
  ev[8] = newevent(165, makevector2(5,5),makevector2(-0.2,0.2), mobjp[3],"plus8");
  ev[9] = newevent(180, makevector2(25,4),makevector2(0.1,0.3), mobjp[4],"plus9");
  ev[10] = newevent(210, makevector2(30,6),makevector2(0.3,0.2), mobjp[5],"plus10");
  ev[11] = newevent(230, makevector2(15,4),makevector2(0.1,0.2), mobjp[6],"plus11");
  ev[12] = newevent(245, makevector2(25,5),makevector2(-0.1,0.3), mobjp[7],"plus12");
  ev[13] = newevent(265, makevector2(25,3),makevector2(0.2,0.1), mobjp[8],"plus13");
  ev[14] = newevent(1000000, makevector2(30,1),makevector2(0,1), mobjp[0],"dummy");
  for(i=0;i<EVNUM;i++){
    addevent(ev[i]);
  }
  resetmark();
}

void init(void){
  initscreen();
  initwalls();
  initmom();
  initobjects();
  initmovingobjects();
  initscenario();
  setevents();
}


void getstate(vector2* ret, int* isfire){
  static vector2 pos = {SCREENWIDTH/2-1, SCREENHEIGHT-3}; 
  *isfire = 0;
  int in = gameioread();
  switch(in){
  case 'g':
  case 'G':
    pos.x++;
    break;
  case 'f':
  case 'F':
    pos.x--;
    break;
  case 't':
  case 'T':
    pos.y--;
    break;
  case 'v':
  case 'V':
    pos.y++;
    break;
  case ' ':
    *isfire = 1;
  } 

  *ret = pos;
}

void show(void){
  int x,y;
  for(y=0;y<SCREENHEIGHT;y++){
    for(x=0;x<SCREENWIDTH;x++){
      gameioput(x,y,dispbuffer[SCREENWIDTH*y+x]);
    }
  }
  gameiorefresh();
}

void gameloop(void){ 
  int time = 0;
  vector2 tmpv;
  event* e = getnextevent();
  int num = 0;
  while(1){
    gameiousleep(30000);
    if(time%speedlevel == 0){
      scrollwall();
      while(e!= NULL && e->time*speedlevel < time){
        addmo(e->mobj, e->pos, e->vel);
        e = getnextevent();
      }
      score += 10 / speedlevel;
      if(score > 1200)
	break;
    }
    getstate(&mypos, &isfire);
    gameioput(SCREENWIDTH+3,1,'0'+(int)mypos.x/10);
    gameioput(SCREENWIDTH+4,1,'0'+(int)mypos.x%10);
    gameioput(SCREENWIDTH+6,1,'0'+(int)mypos.y/10);
    gameioput(SCREENWIDTH+7,1,'0'+(int)mypos.y%10);
    putwalls(SCREENHEIGHT);
    putmo();
    onestepmo();
    if(checkcollision(mypos, objp[1]) != NONOBJ){
      break;
    }
    if(isfire){
      tmpv = mypos;
      tmpv.x +=1;
      tmpv.y -=2;
      addmo(mobjp[1], tmpv, makevector2(0,-1));
    }
    mobjp[2]->pos = mypos;
    dispm(mobjp[2]);
    show();
    time++;
    }
  }

int main(void){
  int highscore = 0;
  FILE *fp1, *fp2;
  printf("speedlevel?>");
  scanf("%d",&speedlevel);
  gameioinit();
  gameioclear();
  init();
  
  score = 0;
  gameloop();

  gameiopost();
  printf("score %d\n",score);
  fp1 = fopen("game2.txt", "r");
  fscanf(fp1,"%d", &highscore);
   fclose(fp1);
  if(score > highscore){
    highscore = score;
    printf("New record!!!\n");
 fp2 = fopen("game2.txt", "w");
 fprintf(fp2, "%d\n", highscore);
  fclose(fp2);
  }
  if(score > 1200)
    printf("You win!! Congrats!!\n");
  return 0;
}
